#include "printf.h"
#include "sta013.h"
#include "as31glue.h"

code int mpeg1_bitrates[16]={-1, 32, 40, 48, 56, 64, 80, 96, 112,
	128, 160, 192, 224, 256, 320, -1};
code int mpeg2_bitrates[16]={-1, 8, 16, 24, 32, 40, 48, 56, 64,
	80, 96, 112, 128, 144, 160, -1};
code unsigned char mpeg1_freq[4]={44, 48, 32, 0};
code unsigned char mpeg2_freq[4]={22, 24, 16, 0};
code unsigned char mpeg25_freq[4]={11, 12, 8, 0};

struct playback_struct playback;


static xdata union {
        struct {
                unsigned char l;
                unsigned char m;
                unsigned char h;
                unsigned char sync;
        } byte;
        unsigned long ul;
} header;


void update_playback_parms(void)
{

        header.ul = sta013_read_header();

	// TODO: there's a bug in sta013_read_header (or perhaps the
	//  I2C communication code) where every other attempt to read
	//  the header files.  Uncomment this line to be able to see it.
        // printf("hdr = %lx\r\n", header.ul);

        if (header.byte.sync != 2) return;

        if (header.byte.h & 0x08) {     /* mpeg1 stream */
                playback.bitrate = mpeg1_bitrates[header.byte.m >> 4];
                playback.freq = mpeg1_freq[(header.byte.m >> 2) & 3];
        } else {                /* mpeg2 stream */
                playback.bitrate = mpeg2_bitrates[header.byte.m >> 4];
                if (header.byte.h & 0x10) {     /* mpeg2.0 */
                        playback.freq = mpeg2_freq[(header.byte.m >> 2) & 3];
                } else {                /* mpeg2.5 */
                        playback.freq = mpeg25_freq[(header.byte.m >> 2) & 3];
                }
        }
        if ((header.byte.l & 0xC0) == 0xC0) {
                playback.mode = "  Mono";
        } else {
                playback.mode = "Stereo";
        }
        playback.mode_known = 1;
}



